DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Protected Member Functions | Private Attributes | Friends | List of all members
DcmOtherByteOtherWord Class Reference

a class representing the DICOM value representations 'Other Byte' (OB) and 'Other Word' (OW) More...

Inheritance diagram for DcmOtherByteOtherWord:

## Public Member Functions
| DcmOtherByteOtherWord (const DcmTag &tag)
| constructor. More...
| DcmOtherByteOtherWord (const DcmOtherByteOtherWord &old)
| copy constructor More...
virtual int | compare (const DcmElement &rhs) const
| comparison operator that compares the normalized value of this object with a given object of the same type. More...
virtual | ~DcmOtherByteOtherWord ()
| destructor
DcmOtherByteOtherWord & | operator= (const DcmOtherByteOtherWord &obj)
| assignment operator More...
virtual DcmObject * | clone () const
| clone method More...
virtual OFCondition | copyFrom (const DcmObject &rhs)
| Virtual object copying. More...
virtual DcmEVR | ident () const
| get element type identifier More...
virtual OFCondition | checkValue (const OFString &vm="", const OFBool oldFormat=OFFalse)
| check whether stored value conforms to the VR and to the specified VM More...
virtual unsigned long | getVM ()
| get value multiplicity More...
virtual unsigned long | getNumberOfValues ()
| get number of values stored in this element More...
virtual OFCondition | setVR (DcmEVR vr)
| set/change the current value representation More...
virtual void | print (STD_NAMESPACE ostream &out, const size_t flags=0, const int level=0, const char *pixelFileName=NULL, size_t *pixelCounter=NULL)
| print the current value to a stream. More...
virtual OFBool | canWriteXfer (const E_TransferSyntax newXfer, const E_TransferSyntax oldXfer)
| check whether the transfer syntax can be changed as specified More...
virtual OFCondition | write (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| write object to a stream More...
virtual OFCondition | writeXML (STD_NAMESPACE ostream &out, const size_t flags=0)
| write object in XML format to a stream More...
virtual OFCondition | writeJson (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write object in JSON format to a stream More...
virtual OFCondition | writeSignatureFormat (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| special write method for creation of digital signatures More...
virtual OFCondition | getUint8 (Uint8 &byteVal, const unsigned long pos=0)
| get particular 8 bit value. More...
virtual OFCondition | getUint16 (Uint16 &wordVal, const unsigned long pos=0)
| get particular 16 bit value. More...
virtual OFCondition | getUint8Array (Uint8 *&byteVals)
| get reference to stored 8 bit data. More...
virtual OFCondition | getUint16Array (Uint16 *&wordVals)
| get reference to stored 16 bit data. More...
virtual OFCondition | getOFString (OFString &stringVal, const unsigned long pos, OFBool normalize=OFTrue)
| get a particular value as a character string. More...
virtual OFCondition | getOFStringArray (OFString &stringVal, OFBool normalize=OFTrue)
| get element value as a character string. More...
virtual OFCondition | putUint8Array (const Uint8 *byteValue, const unsigned long numBytes)
| set element value to given 8 bit data. More...
virtual OFCondition | putUint16Array (const Uint16 *wordValue, const unsigned long numWords)
| set element value to given 16 bit data. More...
virtual OFCondition | createUint8Array (const Uint32 numBytes, Uint8 *&bytes)
| create an empty Uint8 array of given number of bytes and set it. More...
virtual OFCondition | createUint16Array (const Uint32 numWords, Uint16 *&words)
| create an empty Uint16 array of given number of words and set it. More...
virtual OFCondition | putString (const char *stringVal)
| set element value from the given character string. More...
virtual OFCondition | putString (const char *stringVal, const Uint32 stringLen)
| set element value from the given character string. More...
virtual OFCondition | verify (const OFBool autocorrect=OFFalse)
| check the currently stored element value More...
Public Member Functions inherited from DcmElement
| DcmElement (const DcmTag &tag, const Uint32 len=0)
| constructor. More...
| DcmElement (const DcmElement &old)
| copy constructor More...
virtual | ~DcmElement ()
| destructor
DcmElement & | operator= (const DcmElement &obj)
| assignment operator More...
virtual Uint32 | calcElementLength (const E_TransferSyntax xfer, const E_EncodingType enctype)
| calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences. More...
virtual Uint32 | getLength (const E_TransferSyntax xfer=EXS_LittleEndianImplicit, const E_EncodingType enctype=EET_UndefinedLength)
| calculate the value length (without attribute tag, VR and length field) of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences. More...
virtual OFBool | isLeaf () const
| check if this element is a leaf node in a dataset tree. More...
virtual OFBool | isElement () const
| check if this element can be safely casted to DcmElement More...
OFBool | valueLoaded () const
| check if value of this element is loaded into main memory More...
virtual void | transferInit ()
| initialize the transfer state of this object. More...
virtual OFCondition | read (DcmInputStream &inStream, const E_TransferSyntax ixfer, const E_GrpLenEncoding glenc=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength)
| This function reads the data value of an attribute which is captured in the input stream and captures this information in this. More...
virtual OFCondition | clear ()
| clear (remove) attribute value More...
virtual OFCondition | loadAllDataIntoMemory ()
| this method loads all attribute values maintained by this object and all sub-objects (in case of a container such as DcmDataset) into memory. More...
virtual OFCondition | getSint16 (Sint16 &val, const unsigned long pos=0)
| retrieve a single value of type Sint16. More...
virtual OFCondition | getSint32 (Sint32 &val, const unsigned long pos=0)
| retrieve a single value of type Sint32. More...
virtual OFCondition | getUint32 (Uint32 &val, const unsigned long pos=0)
| retrieve a single value of type Uint32. More...
virtual OFCondition | getFloat32 (Float32 &val, const unsigned long pos=0)
| retrieve a single value of type Float32. More...
virtual OFCondition | getSint64 (Sint64 &val, const unsigned long pos=0)
| retrieve a single value of type Sint64. More...
virtual OFCondition | getUint64 (Uint64 &val, const unsigned long pos=0)
| retrieve a single value of type Uint64. More...
virtual OFCondition | getFloat64 (Float64 &val, const unsigned long pos=0)
| retrieve a single value of type Float64. More...
virtual OFCondition | getTagVal (DcmTagKey &val, const unsigned long pos=0)
| retrieve a single value of type DcmTagKey. More...
virtual OFCondition | getString (char *&val)
| get a pointer to the element value of the current element as type string. More...
virtual OFCondition | getString (char *&val, Uint32 &len)
| get a pointer to the element value of the current element as type string. More...
virtual OFCondition | getSint16Array (Sint16 *&val)
| get a pointer to the element value of the current element as type Sint16. More...
virtual OFCondition | getSint32Array (Sint32 *&val)
| get a pointer to the element value of the current element as type Sint32. More...
virtual OFCondition | getUint32Array (Uint32 *&val)
| get a pointer to the element value of the current element as type Uint32. More...
virtual OFCondition | getFloat32Array (Float32 *&val)
| get a pointer to the element value of the current element as type Float32. More...
virtual OFCondition | getSint64Array (Sint64 *&val)
| get a pointer to the element value of the current element as type Sint64. More...
virtual OFCondition | getUint64Array (Uint64 *&val)
| get a pointer to the element value of the current element as type Uint64. More...
virtual OFCondition | getFloat64Array (Float64 *&val)
| get a pointer to the element value of the current element as type Float64. More...
OFCondition | detachValueField (OFBool copy=OFFalse)
| detach the value field from the DICOM element (i.e., this object). More...
virtual OFCondition | putOFStringArray (const OFString &val)
| replace the element value by a copy of the given string (which is possibly multi-valued). More...
virtual OFCondition | putSint16 (const Sint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint16 value. More...
virtual OFCondition | putUint16 (const Uint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint16 value. More...
virtual OFCondition | putSint32 (const Sint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint32 value. More...
virtual OFCondition | putUint32 (const Uint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint32 value. More...
virtual OFCondition | putFloat32 (const Float32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float32 value. More...
virtual OFCondition | putSint64 (const Sint64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint64 value. More...
virtual OFCondition | putUint64 (const Uint64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint64 value. More...
virtual OFCondition | putFloat64 (const Float64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float64 value. More...
virtual OFCondition | putTagVal (const DcmTagKey &attrTag, const unsigned long pos=0)
| insert into the element value a copy of the given DcmTagKey value. More...
virtual OFCondition | putSint16Array (const Sint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint16 array (which is possibly multi-valued). More...
virtual OFCondition | putSint32Array (const Sint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint32 array (which is possibly multi-valued). More...
virtual OFCondition | putUint32Array (const Uint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint32 array (which is possibly multi-valued). More...
virtual OFCondition | putFloat32Array (const Float32 *vals, const unsigned long num)
| replace the element value by a copy of the given Float32 array (which is possibly multi-valued). More...
virtual OFCondition | putSint64Array (const Sint64 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint64 array (which is possibly multi-valued). More...
virtual OFCondition | putUint64Array (const Uint64 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint64 array (which is possibly multi-valued). More...
virtual OFCondition | putFloat64Array (const Float64 *vals, const unsigned long num)
| replace the element value by a copy of the given Float64 array (which is possibly multi-valued). More...
virtual OFCondition | getPartialValue (void *targetBuffer, const Uint32 offset, Uint32 numBytes, DcmFileCache *cache=NULL, E_ByteOrder byteOrder=gLocalByteOrder)
| Copy numBytes bytes of data from the attribute value in byteOrder byte order to targetBuffer, starting at byte offset offset of the attribute value. More...
virtual OFCondition | createValueFromTempFile (DcmInputStreamFactory *factory, const Uint32 length, const E_ByteOrder byteOrder)
| replace the attribute value with the content of the given temporary file. More...
virtual void | compact ()
| remove the attribute value from memory if the attribute value can be loaded from file when needed again. More...
virtual OFCondition | getUncompressedFrameSize (DcmItem *dataset, Uint32 &frameSize, OFBool pixelDataIsUncompressed) const
| compute uncompressed frame size of a single frame of this image. More...
virtual OFCondition | getUncompressedFrame (DcmItem *dataset, Uint32 frameNo, Uint32 &startFragment, void *buffer, Uint32 bufSize, OFString &decompressedColorModel, DcmFileCache *cache=NULL)
| access single frame without decompressing or loading a complete multi-frame object. More...
virtual OFCondition | getDecompressedColorModel (DcmItem *dataset, OFString &decompressedColorModel)
| determine color model of the decompressed image More...
virtual OFBool | isUniversalMatch (const OFBool normalize=OFTrue, const OFBool enableWildCardMatching=OFTrue)
| Determine if this element is universal matching. More...
virtual OFBool | matches (const DcmElement &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching. More...
virtual OFBool | combinationMatches (const DcmElement &keySecond, const DcmElement &candidateFirst, const DcmElement &candidateSecond) const
| perform combined attribute matching. More...
const DcmInputStreamFactory * | getInputStream () const
| returns a pointer to the input stream, if available, NULL otherwise. More...
virtual Uint16 | decodedBitsAllocated (Uint16 bitsAllocated, Uint16 bitsStored) const
| determines the effective value of BitsAllocated that a dataset will have after decompression of an image with the given values for bitsAllocated and bitsStored. More...
Public Member Functions inherited from DcmObject
| DcmObject (const DcmTag &tag, const Uint32 len=0)
| constructor. More...
| DcmObject (const DcmObject &obj)
| copy constructor More...
virtual | ~DcmObject ()
| destructor
DcmObject & | operator= (const DcmObject &obj)
| copy assignment operator More...
DcmEVR | getVR () const
| return the value representation assigned to this object. More...
OFBool | isaString () const
| check if this element is a string type, based on the VR. More...
virtual OFBool | isNested () const
| check if this element is nested in a sequence of items, i.e. not a top-level or stand-alone element More...
E_TransferState | transferState () const
| return the current transfer (read/write) state of this object. More...
virtual void | transferEnd (void)
| finalize the transfer state of this object. More...
DcmItem * | getRootItem ()
| get root dataset/item (top-level) that contains this object. More...
virtual DcmItem * | getParentItem ()
| get parent item of this object. More...
DcmObject * | getParent ()
| get parent of this object. More...
const DcmObject * | getParent () const
| get parent of this object. More...
void | setParent (DcmObject *parent)
| set parent of this object. More...
Uint16 | getGTag () const
| return the group number of the attribute tag for this object More...
Uint16 | getETag () const
| return the element number of the attribute tag for this object More...
const DcmTag & | getTag () const
| return const reference to the attribute tag for this object More...
void | setGTag (Uint16 gtag)
| assign group tag (but not element tag) of the attribute tag for this object. More...
virtual OFBool | isSignable () const
| returns true if the current object may be included in a digital signature More...
virtual OFBool | containsUnknownVR () const
| returns true if the object contains an element with Unknown VR at any nesting level More...
virtual OFBool | containsExtendedCharacters (const OFBool checkAllStrings=OFFalse)
| check if this object contains non-ASCII characters More...
virtual OFBool | isAffectedBySpecificCharacterSet () const
| check if this object is affected by SpecificCharacterSet More...
virtual OFCondition | convertCharacterSet (DcmSpecificCharacterSet &converter)
| convert this object from the currently selected source character set to the currently selected destination character set (if affected by SpecificCharacterSet) More...
virtual OFBool | isEmpty (const OFBool normalize=OFTrue)
| check if this object is empty More...
virtual DcmObject * | nextInContainer (const DcmObject *obj)
| this method is only used in container classes derived from this class, that is, DcmItem and DcmSequenceOfItems. More...
virtual OFCondition | nextObject (DcmStack &stack, const OFBool intoSub)
| this method enables a stack based, depth-first traversal of a complete hierarchical DICOM dataset (that is, classes derived from DcmItem or DcmSequenceOfItems). More...
virtual OFCondition | search (const DcmTagKey &xtag, DcmStack &resultStack, E_SearchMode mode=ESM_fromHere, OFBool searchIntoSub=OFTrue)
| a complex, stack-based, hierarchical search method. More...
Uint32 | getLengthField () const
| return the current value of the Length field (which is different from the functionality of the public getLength() method). More...

## Protected Member Functions
| DcmOtherByteOtherWord (const DcmTag &tag, const Uint32 len)
| constructor. More...
virtual void | postLoadValue ()
| method is called after the element value has been loaded. More...
OFCondition | alignValue ()
| align the element value to an even length (padding) More...
void | printPixel (STD_NAMESPACE ostream &out, const size_t flags, const int level, const char *pixelFileName, size_t *pixelCounter)
| print pixel data and optionally write it to a binary file. More...
virtual int | compareValues (const void *myValue, const void *rhsValue, const unsigned long valLength) const
| compares two binary values for equality. More...
Protected Member Functions inherited from DcmElement
void * | getValue (const E_ByteOrder newByteOrder=gLocalByteOrder)
| This function returns this element's value. More...
OFCondition | changeValue (const void *value, const Uint32 position, const Uint32 num)
| insert into the element value a copy of the given raw value. More...
OFCondition | putValue (const void *value, const Uint32 length)
| replace the element value by a copy of the given raw data block More...
OFCondition | createEmptyValue (const Uint32 length)
| create a new, empty value field of given size. More...
OFCondition | loadValue (DcmInputStream *inStream=NULL)
| This function reads the data value of an attribute and stores the information which was read in this. More...
virtual Uint8 * | newValueField ()
| This function creates a byte array of Length bytes and returns this array. More...
void | swapValueField (size_t valueWidth)
| swaps the content of the value field (if loaded) from big-endian to little-endian or back More...
virtual void | writeXMLStartTag (STD_NAMESPACE ostream &out, const size_t flags, const char *attrText=NULL)
| write element start tag in XML format More...
virtual void | writeXMLEndTag (STD_NAMESPACE ostream &out, const size_t flags)
| write element end tag in XML format More...
virtual void | writeJsonOpener (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element start tag in JSON format More...
virtual void | writeJsonCloser (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element end tag in JSON format More...
E_ByteOrder | getByteOrder () const
| return the current byte order of the value field More...
void | setByteOrder (E_ByteOrder val)
| set the current byte order of the value field More...
Protected Member Functions inherited from DcmObject
void | printNestingLevel (STD_NAMESPACE ostream &out, const size_t flags, const int level)
| print line indentation, e.g. a couple of spaces for each nesting level. More...
void | printInfoLineStart (STD_NAMESPACE ostream &out, const size_t flags, const int level, DcmTag *tag=NULL)
| print beginning of the info line. More...
void | printInfoLineEnd (STD_NAMESPACE ostream &out, const size_t flags, const unsigned long printedLength=0xffffffff, DcmTag *tag=NULL)
| print end of the info line. More...
virtual void | printInfoLine (STD_NAMESPACE ostream &out, const size_t flags, const int level=0, const char *info=NULL, DcmTag *tag=NULL, const OFBool isInfo=OFTrue)
| print given text with element information. More...
virtual OFCondition | writeTagAndLength (DcmOutputStream &outStream, const E_TransferSyntax oxfer, Uint32 &writtenBytes) const
| write tag, VR and length field to the given output stream More...
virtual Uint32 | getTagAndLengthSize (const E_TransferSyntax oxfer) const
| return the number of bytes needed to serialize the tag, VR and length information of the current object using the given transfer syntax. More...
const char * | getTagName ()
| return the DICOM attribute tag name for this object. More...
void | setTagVR (DcmEVR vr)
| set the VR for this attribute More...
E_TransferState | getTransferState () const
| return the current transfer state of this object during serialization/deserialization More...
void | setTransferState (E_TransferState newState)
| set the current transfer state of this object during serialization/deserialization More...
Uint32 | getTransferredBytes () const
| return the number of transferred bytes for this object during serialization/deserialization More...
void | setTransferredBytes (Uint32 val)
| set the number of transferred bytes for this object during serialization/deserialization More...
void | incTransferredBytes (Uint32 val)
| add to the number of transferred bytes for this object during serialization/deserialization More...
void | setLengthField (Uint32 val)
| set the current value of the Length field More...

## Private Attributes
OFBool | compactAfterTransfer
| this flag is used during write operations and indicates that compact() should be called once the write operation finishes.

## Friends
class | DcmItem

## Additional Inherited Members
Static Public Member Functions inherited from DcmElement
static int | scanValue (const OFString &value, const OFString &vr, const size_t pos=0, const size_t num=OFString_npos)
| scan string value for conformance with given value representation (VR) More...
static int | scanValue (const OFString &vr, const char *const value, const size_t size)
| scan string value for conformance with given value representation (VR) More...
static unsigned long | determineVM (const char *str, const size_t len)
| determine the number of values stored in a string, i.e. the value multiplicity (VM) More...
static size_t | getValueFromString (const char *str, const size_t pos, const size_t len, OFString &val)
| get the first value stored in the given string. More...
static OFCondition | checkVM (const unsigned long vmNum, const OFString &vmStr)
| check for correct value multiplicity (VM) More...
Static Protected Member Functions inherited from DcmObject
static OFCondition | writeTag (DcmOutputStream &outStream, const DcmTag &tag, const E_TransferSyntax oxfer)
| static helper function that writes a given attribute tag to a binary output stream using the byte order indicated by the transfer syntax. More...
Protected Attributes inherited from DcmObject
OFCondition | errorFlag
| error flag for this object.

## Detailed Description

a class representing the DICOM value representations 'Other Byte' (OB) and 'Other Word' (OW)

## Constructor & Destructor Documentation

## ◆ DcmOtherByteOtherWord() [1/3]

DcmOtherByteOtherWord::DcmOtherByteOtherWord | ( | const DcmTag & | tag | ) |

constructor.

Create new element from given tag.

Parameters

  tag | DICOM tag for the new element

## ◆ DcmOtherByteOtherWord() [2/3]

DcmOtherByteOtherWord::DcmOtherByteOtherWord | ( | const DcmOtherByteOtherWord & | old | ) |

copy constructor

Parameters

  old | element to be copied

## ◆ DcmOtherByteOtherWord() [3/3]

DcmOtherByteOtherWord::DcmOtherByteOtherWord | ( | const DcmTag & | tag,
|  | const Uint32 | len
| ) |  |
| protected

constructor.

Create new element from given tag and length. Only reachable from friend classes since construction with length different from 0 leads to a state with length being set but the element's value still being uninitialized. This can lead to crashes when the value is read or written. Thus the method calling this constructor with length > 0 must ensure that the element's value is explicitly initialized, too. Create new element from given tag and length.

Parameters

  tag | DICOM tag for the new element
  len | value length for the new element

## Member Function Documentation

## ◆ alignValue()

OFCondition DcmOtherByteOtherWord::alignValue | ( |  | ) |
| protected

align the element value to an even length (padding)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ canWriteXfer()

virtual OFBool DcmOtherByteOtherWord::canWriteXfer | ( | const E_TransferSyntax | newXfer,
|  | const E_TransferSyntax | oldXfer
| ) |  |
| virtual

check whether the transfer syntax can be changed as specified

Parameters

  newXfer | transfer syntax to be checked
  oldXfer | not used

Returns
  OFTrue if transfer syntax can be changed to the new one, OFFalse otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPixelData.

## ◆ checkValue()

virtual OFCondition DcmOtherByteOtherWord::checkValue | ( | const OFString & | vm = `""`,
|  | const OFBool | oldFormat = `OFFalse`
| ) |  |
| virtual

check whether stored value conforms to the VR and to the specified VM

Parameters

  vm | parameter not used for this VR
  oldFormat | parameter not used for this VR (only for DA, TM)

Returns
  always returns EC_Normal, i.e. currently no checks are performed

Reimplemented from DcmElement.

## ◆ clone()

virtual DcmObject* DcmOtherByteOtherWord::clone | ( |  | ) | const
| inline virtual

clone method

Returns
  deep copy of this object

Implements DcmObject.

Reimplemented in DcmPolymorphOBOW, DcmPixelItem, DcmPixelData, and DcmOverlayData.

## ◆ compare()

virtual int DcmOtherByteOtherWord::compare | ( | const DcmElement & | rhs | ) | const
| virtual

comparison operator that compares the normalized value of this object with a given object of the same type.

The tag of the element is also considered as the first component that is compared, followed by the object types (VR, i.e. DCMTK'S EVR) and the comparison of all value components of the object, preferably in the order declared in the object (if applicable). The implementation for DcmOtherByteOtherWord does compare the values of two elements in local endianness.

Parameters

  rhs | the right hand side of the comparison

Returns
  0 if the object values are equal. -1 if this element has fewer components than the rhs element. Also -1 if the value of the first component that does not match is lower in this object than in rhs. Also returned if rhs cannot be casted to this object type or both objects are of different VR (i.e. the DcmEVR returned by the element's ident() call are different). 1 if either this element has more components than the rhs element, or if the first component that does not match is greater in this object than in rhs object.

Implements DcmElement.

Reimplemented in DcmPolymorphOBOW, and DcmPixelData.

## ◆ compareValues()

virtual int DcmOtherByteOtherWord::compareValues | ( | const void * | myValue,
|  | const void * | rhsValue,
|  | const unsigned long | valLength
| ) |  | const
| protected virtual

compares two binary values for equality.

This function compares the binary data pointed to by `myValue` and `rhsValue` for equality up to the specified length `valLength`. See compare() method for more details.

Parameters

  myValue | pointer to the first value to compare.
  rhsValue | pointer to the second value to compare.
  valLength | the number of bytes to compare.

Returns
  an integer less than, equal to, or greater than zero if the first value is found to be less than, equal to, or greater than the second value.

## ◆ copyFrom()

virtual OFCondition DcmOtherByteOtherWord::copyFrom | ( | const DcmObject & | rhs | ) |
| virtual

Virtual object copying.

This method can be used for DcmObject and derived classes to get a deep copy of an object. Internally the assignment operator is called if the given DcmObject parameter is of the same type as "this" object instance. If not, an error is returned. This function permits copying an object by value in a virtual way which therefore is different to just calling the assignment operator of DcmElement which could result in slicing the object.

Parameters

  rhs | - [in] The instance to copy from. Has to be of the same class type as "this" object

Returns
  EC_Normal if copying was successful, error otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPolymorphOBOW, DcmPixelItem, DcmPixelData, and DcmOverlayData.

## ◆ createUint16Array()

virtual OFCondition DcmOtherByteOtherWord::createUint16Array | ( | const Uint32 | numWords,
|  | Uint16 *& | words
| ) |  |
| virtual

create an empty Uint16 array of given number of words and set it.

All array elements are initialized with a value of 0 (using 'memset'). This method is only applicable to OW data.

Parameters

  numWords | number of words (16 bit) to be created
  words | stores the pointer to the resulting buffer

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPolymorphOBOW, and DcmPixelData.

## ◆ createUint8Array()

virtual OFCondition DcmOtherByteOtherWord::createUint8Array | ( | const Uint32 | numBytes,
|  | Uint8 *& | bytes
| ) |  |
| virtual

create an empty Uint8 array of given number of bytes and set it.

All array elements are initialized with a value of 0 (using 'memset'). This method is only applicable to non-OW data, e.g. OB.

Parameters

  numBytes | number of bytes (8 bit) to be created
  bytes | stores the pointer to the resulting buffer

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPolymorphOBOW, and DcmPixelData.

## ◆ getNumberOfValues()

virtual unsigned long DcmOtherByteOtherWord::getNumberOfValues | ( |  | ) |
| virtual

get number of values stored in this element

Returns
  number of values in this element

Implements DcmObject.

## ◆ getOFString()

virtual OFCondition DcmOtherByteOtherWord::getOFString | ( | OFString & | stringVal,
|  | const unsigned long | pos,
|  | OFBool | normalize = `OFTrue`
| ) |  |
| virtual

get a particular value as a character string.

The numeric value is converted to hex mode, i.e. an 8 bit value is represented by 2 characters (00..ff) and a 16 bit value by 4 characters (0000..ffff).

Parameters

  stringVal | variable in which the result value is stored
  pos | index of the value in case of multi-valued elements (0..vm-1)
  normalize | not used

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## ◆ getOFStringArray()

virtual OFCondition DcmOtherByteOtherWord::getOFStringArray | ( | OFString & | stringVal,
|  | OFBool | normalize = `OFTrue`
| ) |  |
| virtual

get element value as a character string.

The numeric values are converted to hex mode, i.e. an 8 bit value is represented by 2 characters (00..ff) and a 16 bit value by 4 characters (0000..ffff). In case of VM > 1 the individual values are separated by a backslash ('\').

Parameters

  stringVal | variable in which the result value is stored
  normalize | not used

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## ◆ getUint16()

virtual OFCondition DcmOtherByteOtherWord::getUint16 | ( | Uint16 & | wordVal,
|  | const unsigned long | pos = `0`
| ) |  |
| virtual

get particular 16 bit value.

This method is only applicable to OW data.

Parameters

  wordVal | reference to result variable (cleared in case of error)
  pos | index of the value to be retrieved (0..vm-1)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## ◆ getUint16Array()

virtual OFCondition DcmOtherByteOtherWord::getUint16Array | ( | Uint16 *& | wordVals | ) |
| virtual

get reference to stored 16 bit data.

This method is only applicable to OW data.

Parameters

  wordVals | reference to result variable

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPolymorphOBOW.

## ◆ getUint8()

virtual OFCondition DcmOtherByteOtherWord::getUint8 | ( | Uint8 & | byteVal,
|  | const unsigned long | pos = `0`
| ) |  |
| virtual

get particular 8 bit value.

This method is only applicable to non-OW data, e.g. OB.

Parameters

  byteVal | reference to result variable (cleared in case of error)
  pos | index of the value to be retrieved (0..vm-1)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## ◆ getUint8Array()

virtual OFCondition DcmOtherByteOtherWord::getUint8Array | ( | Uint8 *& | byteVals | ) |
| virtual

get reference to stored 8 bit data.

This method is only applicable to non-OW data, e.g. OB.

Parameters

  byteVals | reference to result variable

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPolymorphOBOW.

## ◆ getVM()

virtual unsigned long DcmOtherByteOtherWord::getVM | ( |  | ) |
| virtual

get value multiplicity

Returns
  always returns 1 (according to the DICOM standard)

Implements DcmObject.

## ◆ ident()

virtual DcmEVR DcmOtherByteOtherWord::ident | ( |  | ) | const
| virtual

get element type identifier

Returns
  type identifier of this class

Implements DcmObject.

Reimplemented in DcmPixelItem, DcmPixelData, and DcmOverlayData.

## ◆ operator=()

DcmOtherByteOtherWord& DcmOtherByteOtherWord::operator= | ( | const DcmOtherByteOtherWord & | obj | ) |

assignment operator

Parameters

  obj | element to be assigned/copied

Returns
  reference to this object

## ◆ postLoadValue()

virtual void DcmOtherByteOtherWord::postLoadValue | ( |  | ) |
| protected virtual

method is called after the element value has been loaded.

Can be used to correct the value before it is used for the first time.

Reimplemented from DcmElement.

## ◆ print()

virtual void DcmOtherByteOtherWord::print | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = `0`,
|  | const int | level = `0`,
|  | const char * | pixelFileName = `NULL`,
|  | size_t * | pixelCounter = `NULL`
| ) |  |
| virtual

print the current value to a stream.

The output format of the binary value is a backslash separated sequence of 2- or 4-digit hex numbers, e.g. "00\01\dd" or "0000\7777\aaaa\ffff".

Parameters

  out | output stream
  flags | optional flag used to customize the output (see DCMTypes::PF_xxx)
  level | current level of nested items. Used for indentation.
  pixelFileName | not used
  pixelCounter | not used

Implements DcmObject.

Reimplemented in DcmPixelItem, and DcmPixelData.

## ◆ printPixel()

void DcmOtherByteOtherWord::printPixel | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags,
|  | const int | level,
|  | const char * | pixelFileName,
|  | size_t * | pixelCounter
| ) |  |
| protected

print pixel data and optionally write it to a binary file.

Optional pixel data file is always written in little endian byte-ordering.

Parameters

  out | output stream
  flags | optional flag used to customize the output (see DCMTypes::PF_xxx)
  level | current level of nested items. Used for indentation.
  pixelFileName | optional filename used to write the raw pixel data file
  pixelCounter | optional counter used for automatic pixel data filename creation

## ◆ putString() [1/2]

virtual OFCondition DcmOtherByteOtherWord::putString | ( | const char * | stringVal | ) |
| virtual

set element value from the given character string.

The input string is expected to have the same format as described for 'getOFStringArray()' above, i.e. a backslash separated sequence of hexa-decimal numbers.

Parameters

  stringVal | input character string

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## ◆ putString() [2/2]

virtual OFCondition DcmOtherByteOtherWord::putString | ( | const char * | stringVal,
|  | const Uint32 | stringLen
| ) |  |
| virtual

set element value from the given character string.

The input string is expected to have the same format as described for 'getOFStringArray()' above, i.e. a backslash separated sequence of hexa-decimal numbers. The length of the string has to be specified explicitly. The string can, therefore, also contain more than one NULL byte.

Parameters

  stringVal | input character string
  stringLen | length of the string (number of characters without the trailing NULL byte)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## ◆ putUint16Array()

virtual OFCondition DcmOtherByteOtherWord::putUint16Array | ( | const Uint16 * | wordValue,
|  | const unsigned long | numWords
| ) |  |
| virtual

set element value to given 16 bit data.

This method is only applicable to OW data.

Parameters

  wordValue | 16 bit data to be set (copied)
  numWords | number of words (16 bit) to be set. Local byte-ordering expected.

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPixelData, and DcmPolymorphOBOW.

## ◆ putUint8Array()

virtual OFCondition DcmOtherByteOtherWord::putUint8Array | ( | const Uint8 * | byteValue,
|  | const unsigned long | numBytes
| ) |  |
| virtual

set element value to given 8 bit data.

This method is only applicable to non-OW data, e.g. OB.

Parameters

  byteValue | 8 bit data to be set (copied)
  numBytes | number of bytes (8 bit) to be set

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPolymorphOBOW, and DcmPixelData.

## ◆ setVR()

virtual OFCondition DcmOtherByteOtherWord::setVR | ( | DcmEVR | vr | ) |
| virtual

set/change the current value representation

Parameters

  vr | new value representation to be set. All VRs except for OW (Other Word String) are treated as 8 bit data (OB). This is particularly useful for unknown (UN) or unsupported VRs.

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmObject.

Reimplemented in DcmPixelData.

## ◆ verify()

virtual OFCondition DcmOtherByteOtherWord::verify | ( | const OFBool | autocorrect = `OFFalse` | ) |
| virtual

check the currently stored element value

Parameters

  autocorrect | correct value padding (even length) if OFTrue

Returns
  status, EC_Normal if value length is correct, an error code otherwise

Implements DcmObject.

## ◆ write()

virtual OFCondition DcmOtherByteOtherWord::write | ( | DcmOutputStream & | outStream,
|  | const E_TransferSyntax | oxfer,
|  | const E_EncodingType | enctype,
|  | DcmWriteCache * | wcache
| ) |  |
| virtual

write object to a stream

Parameters

  outStream | DICOM output stream
  oxfer | output transfer syntax
  enctype | encoding types (undefined or explicit length)
  wcache | pointer to write cache object, may be NULL

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPolymorphOBOW, and DcmPixelData.

## ◆ writeJson()

virtual OFCondition DcmOtherByteOtherWord::writeJson | ( | STD_NAMESPACE ostream & | out,
|  | DcmJsonFormat & | format
| ) |  |
| virtual

write object in JSON format to a stream

Parameters

  out | output stream to which the JSON document is written
  format | used to format and customize the output

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPixelData.

## ◆ writeSignatureFormat()

virtual OFCondition DcmOtherByteOtherWord::writeSignatureFormat | ( | DcmOutputStream & | outStream,
|  | const E_TransferSyntax | oxfer,
|  | const E_EncodingType | enctype,
|  | DcmWriteCache * | wcache
| ) |  |
| virtual

special write method for creation of digital signatures

Parameters

  outStream | DICOM output stream
  oxfer | output transfer syntax
  enctype | encoding types (undefined or explicit length)
  wcache | pointer to write cache object, may be NULL

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPolymorphOBOW, DcmPixelItem, and DcmPixelData.

## ◆ writeXML()

virtual OFCondition DcmOtherByteOtherWord::writeXML | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = `0`
| ) |  |
| virtual

write object in XML format to a stream

Parameters

  out | output stream to which the XML document is written
  flags | optional flag used to customize the output (see DCMTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPixelItem, and DcmPixelData.

The documentation for this class was generated from the following file:

- dcmdata/include/dcmtk/dcmdata/dcvrobow.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1